#include "procenty.h"
#include "ui_procenty.h"
#include "QMessageBox"
#include "QClipboard"


// zmienna globalna przechowująca przelicznik i jednocześnie tryb programu (procenty/promile)
double przelicznik = 0;

// zmienna globalna przechowująca informację o wyświetleniu okna kopiowania obliczeń do schowka
bool schowekInfo = false;

// obiekt polskiej lokalizacji (używany dla prawidłowego formatu liczb)
QLocale polski( QLocale::Polish );


// ====================================


// inicjacja okna Qt - konstruktor i destruktor


Procenty::Procenty(QWidget *parent) :
	QMainWindow(parent),
	ui(new Ui::Procenty)
{
	ui->setupUi(this);

	// wyczyszczenie wszystkich pól, ustawienie domyślnego trybu
	on_actionZmienTryb_triggered();
}

Procenty::~Procenty()
{
	delete ui;
}


// ====================================


// OBLICZANIE: metoda obliczająca procent danej liczby
void Procenty::obliczProcentLiczby()
{
	double procent = ui->pole_1_proc->value();
	double liczba  = ui->pole_1_liczba->value();

	if ( procent == 0 || liczba == 0 ) return;

	double wynik = liczba * (procent/przelicznik);
	pokazWynik( polski.toString(liczba) + " * " + polski.toString(procent) + ((przelicznik==100)?"%":"‰") + " = " + polski.toString(liczba) + " * " + polski.toString(procent/przelicznik) + " = " + polski.toString(wynik) );
}

// OBLICZANIE: metoda obliczająca procent danej liczby
void Procenty::obliczLiczbeProcentu()
{
	double procent = ui->pole_2_proc->value();
	double liczba  = ui->pole_2_liczba->value();

	if ( procent == 0 || liczba == 0 ) return;

	double wynik = liczba / (procent/przelicznik);
	pokazWynik( polski.toString(liczba) + " / " + polski.toString(procent) + ((przelicznik==100)?"%":"‰") + " = " + polski.toString(liczba) + " / " + polski.toString(procent/przelicznik) + " = " + polski.toString(wynik) );
}

// OBLICZANIE: metoda obliczająca procentowy stosunek liczb
void Procenty::obliczStosunekLiczb()
{
	double liczba1 = ui->pole_3_liczba1->value();
	double liczba2 = ui->pole_3_liczba2->value();

	if ( liczba1 == 0 || liczba2 == 0 ) return;

	double wynik = (liczba2/liczba1) * przelicznik;
	pokazWynik( "(" + polski.toString(liczba2) + " / " + polski.toString(liczba1) + ") * " + polski.toString(przelicznik) + ((przelicznik==100)?"%":"‰") + " = " + polski.toString(liczba2/liczba1) + " * " + polski.toString(przelicznik) + ((przelicznik==100)?"%":"‰") + " = " + polski.toString(wynik) + ((przelicznik==100)?"%":"‰") );
}


// ====================================


// PROGRAM: wyświetlenie wyniku
void Procenty::pokazWynik( QString wynik = "" )
{
	ui->wynik_pole->setText( wynik );
}

// PROGRAM: przełączenie wskaźnika (znaczka >>)
void Procenty::przelaczWskaznik( int wiersz = 0 )
{
	ui->label_1_wsk->setStyleSheet( (wiersz==1) ? "" : "color: rgba(0,0,0,0)" );
	ui->label_2_wsk->setStyleSheet( (wiersz==2) ? "" : "color: rgba(0,0,0,0)" );
	ui->label_3_wsk->setStyleSheet( (wiersz==3) ? "" : "color: rgba(0,0,0,0)" );
}


// ====================================


// SLOTY: reagują na sygnał wpisania liczb do pól, wywołują funkcje obliczające

void Procenty::on_pole_1_proc_valueChanged(double arg1)
{
	pokazWynik();
	if ( arg1 != 0 ) obliczProcentLiczby();
	przelaczWskaznik(1);
}

void Procenty::on_pole_1_liczba_valueChanged(double arg1)
{
	pokazWynik();
	if ( arg1 != 0 ) obliczProcentLiczby();
	przelaczWskaznik(1);
}

void Procenty::on_pole_2_proc_valueChanged(double arg1)
{
	pokazWynik();
	if ( arg1 != 0 ) obliczLiczbeProcentu();
	przelaczWskaznik(2);
}

void Procenty::on_pole_2_liczba_valueChanged(double arg1)
{
	pokazWynik();
	if ( arg1 != 0 ) obliczLiczbeProcentu();
	przelaczWskaznik(2);
}

void Procenty::on_pole_3_liczba1_valueChanged(double arg1)
{
	pokazWynik();
	if ( arg1 != 0 ) obliczStosunekLiczb();
	przelaczWskaznik(3);
}

void Procenty::on_pole_3_liczba2_valueChanged(double arg1)
{
	pokazWynik();
	if ( arg1 != 0 ) obliczStosunekLiczb();
	przelaczWskaznik(3);
}


// ====================================


// AKCJA: zmiana trybu między procentami i promilami
void Procenty::on_actionZmienTryb_triggered()
{
	pokazWynik();
	przelaczWskaznik();

	// z procentów na promile
	if ( przelicznik == 100 )
	{
		przelicznik = 1000;

		this->setWindowTitle("Procenty 2.0 — tryb promili");
		ui->centralWidget->setStyleSheet("background: #FFDDF7; color: #000; font-size: 12pt");

		ui->label_1_proc->setText("‰");
		ui->label_2_proc->setText("‰");
		ui->label_3_proc->setText("‰");
	}

	// z promili na procenty
	else
	{
		przelicznik = 100;

		this->setWindowTitle("Procenty 2.0 — tryb procentów");
		ui->centralWidget->setStyleSheet("background: #DDFFDD; color: #000; font-size: 12pt");

		ui->label_1_proc->setText("%");
		ui->label_2_proc->setText("%");
		ui->label_3_proc->setText("%");
	}
}

// AKCJA: czyszczenie wszystkich pól tekstowych, wyniku i wskaźnika
void Procenty::on_actionWyczysc_triggered()
{
	ui->pole_1_liczba->setValue(0);
	ui->pole_1_proc->setValue(0);
	ui->pole_2_liczba->setValue(0);
	ui->pole_2_proc->setValue(0);
	ui->pole_3_liczba1->setValue(0);
	ui->pole_3_liczba2->setValue(0);

	przelaczWskaznik();
	pokazWynik();
}

// AKCJA: okienko o programie ;-)
void Procenty::on_actionOProgramie_triggered()
{
	QMessageBox::about( this,
		"Procenty 2.0 — o programie",
		"© Tomasz Gąsior 2010-2015, licencja LGPL, 2015-08-11<br><a href=\"http://tomaszgasior.kao.pl/procenty\">www.tomaszgasior.kao.pl/procenty</a><br><br>To mój pierwszy program napisany w bibliotece Qt.<br>Wykorzystano ikony <a href=\"https://numixproject.org\">Numix</a> i oczywiście <a href=\"http://www.qt.io\">Qt5</a>."
	);
}


// ====================================


// AKCJA: kopiowanie do schowka po kliknięciu PPM obliczeń
void Procenty::on_wynik_pole_customContextMenuRequested()
{
	if ( ui->wynik_pole->text().isEmpty() ) return;

	QClipboard *schowek = QApplication::clipboard();
	schowek->setText( ui->wynik_pole->text() );

	if ( !schowekInfo ) {
		QMessageBox::information(this,
			"Procenty 2.0 — obliczenia",
			"Po kliknięciu prawym przyciskiem myszy \nobliczenia są kopiowane do schowka. ;-)"
		);
		schowekInfo = true;
	}
}
